MODULE laufl;

SFR P1L; eDP1L; T3IC; T2CON; T3CON; T2; T3; PSW;

VAR i: INTEGER;
    ledstat: INTEGER;
    ledsup: BOOLEAN;

    	PROCEDURE* ISR[35]; (* Timer3-Interrupt *)
    	BEGIN 
    	  IF ledsup THEN
    	    ledstat := ledstat * 2;
    	    P1L := $FF - ledstat;
    	    IF ledstat = 128 THEN ledsup := FALSE; END
    	  ELSE ledstat := ledstat DIV 2;
    	    P1L := $FF - ledstat;
    	    IF ledstat = 1 THEN ledsup := TRUE; END
    	  END
    	END ISR;

	PROCEDURE* InitTimer;
	  VAR t: INTEGER;
	BEGIN (* T3 von T2 reloaded, 200 ms Laufzeit? *)
	  T2CON := $27; (* Reloadmodus *)
	  T2 := 31250; (* Relaodwert *)
	  (* T3 als downcounting Timer mit Prescaler = 128.
	    128 * 31250 * 50 ns = 0,2 s *)
	  T3CON := $02C4; (* T3 als Timer, gestartet *);
	  (* T3-Interrupt mit Prioritt 01/0 freigeben *)
	  T3IC := 68;
	END InitTimer;
	
BEGIN eDP1L := 255; 
  P1L := 254; 
  InitTimer; 
  i := PSW;
  PSW := i + 2048;  (* Set IEN *)
  ledstat := 1; ledsup := TRUE;
  REPEAT Sleep UNTIL ledstat > 256;
END laufl.
